
package gus05.framework.tools;

import gus05.framework.features.Support;

import java.util.*;
import java.awt.event.*;


public class DefaultSupport implements Support, Send {

    
    private Vector listeners;
    
    public DefaultSupport()
	{listeners = new Vector();}
    
    
	
    
    //*****************************************
	
	public final static int eventID = 1000;
	
	public synchronized void addActionListener(ActionListener listener)
	{listeners.add(listener);}

	public synchronized void removeActionListener(ActionListener listener)
	{listeners.remove(listener);}
	
	public synchronized List listeners()
	{return listeners;}
	
	
	
	
	private synchronized void fireActionEvent(Object source, String id)
	{ 
	    if(source==null)source=this;
		ActionEvent evt = new ActionEvent(source,eventID,id);
			
		for(int i=0;i<listeners.size();i++)
		{
		    ActionListener listener = (ActionListener)listeners.get(i);
			listener.actionPerformed(evt);
		}
	}
	
	
	
	
	//*****************************************
	
	private boolean activated = true;
	
	public void setActivated(boolean value)
	{activated = value;}
	
	public boolean isActivated()
	{return activated;}
	

    public void send(Object source, String id)
    {
        if(activated)
        fireActionEvent(source,id);
    }

	
}
